'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _index = require('./../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<Avatar/>', function () {
    it('should pass assistiveText to the prop text of AssistiveText component', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { initials: 'JD', assistiveText: 'for screen readers' }));
        expect(component.find('AssistiveText').prop('text')).toBe('for screen readers');
    });
    it('should have the right class names', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, null));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant is circle and size is x-small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { variant: 'circle', size: 'x-small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is medium', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'medium' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is large', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'large' }));
        expect(component).toMatchSnapshot();
    });
});