'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _index = require('./../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<Badge/>', function () {
    it('should have the right class names when variant default and have a custom class', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { label: 'Badge label', className: 'custom-class' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant inverse', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { label: 'Inverse Badge', variant: 'inverse' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant lightest', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { label: 'Lightest Badge', variant: 'lightest' }));
        expect(component).toMatchSnapshot();
    });
    it('should render an icon on the left when iconName is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { label: 'Lightest Badge', iconName: 'utility:world' }));
        var leftIcon = component.find('[data-id="left-icon"]');
        var rightIcon = component.find('[data-id="right-icon"]');

        expect(leftIcon.prop('isVisible')).toBe(true);
        expect(rightIcon.prop('isVisible')).toBe(false);
    });
    it('should render an icon on the right when iconName is passed and iconPosition is right', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { label: 'Lightest Badge', iconName: 'utility:world', iconPosition: 'right' }));
        var leftIcon = component.find('[data-id="left-icon"]');
        var rightIcon = component.find('[data-id="right-icon"]');

        expect(leftIcon.prop('isVisible')).toBe(false);
        expect(rightIcon.prop('isVisible')).toBe(true);
    });
});