'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _badgeIcon = require('../badgeIcon');

var _badgeIcon2 = _interopRequireDefault(_badgeIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<BadgeIcon/> in the Badge component', function () {
    it('should not have children when the isVisible is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_badgeIcon2.default, null));
        expect(component.children().length).toBe(0);
    });
    it('should have the right class names when the label is not passed', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_badgeIcon2.default, { iconName: 'utility:world', isVisible: true, iconPosition: 'left' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when the label is passed and iconPosition is left', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_badgeIcon2.default, { label: 'testing BadgeIcon', isVisible: true, iconName: 'utility:world', iconPosition: 'left' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when the label is passed and iconPosition is right', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_badgeIcon2.default, { label: 'testing BadgeIcon', isVisible: true, iconName: 'utility:world', iconPosition: 'right' }));
        expect(component).toMatchSnapshot();
    });
});