'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function BadgeIcon(props) {
    var isVisible = props.isVisible,
        iconName = props.iconName,
        iconPosition = props.iconPosition,
        label = props.label;


    var getIconClassName = function getIconClassName() {
        var hasLabel = label !== undefined && label !== null;
        return (0, _classnames2.default)('slds-align_absolute-center', {
            'slds-m-right_xx-small': hasLabel && iconPosition === 'left',
            'slds-m-left_xx-small': hasLabel && iconPosition === 'right'
        });
    };

    if (isVisible) {
        return _react2.default.createElement(_Icon2.default, { size: 'xx-small', iconName: iconName, className: getIconClassName() });
    }
    return null;
}

BadgeIcon.propTypes = {
    isVisible: _propTypes2.default.bool.isRequired,
    iconName: _propTypes2.default.string,
    iconPosition: _propTypes2.default.string.isRequired,
    label: _propTypes2.default.node

};

BadgeIcon.defaultProps = {
    iconName: '',
    label: null
};

exports.default = BadgeIcon;