'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _index = require('./../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<Breadcrumb/>', function () {
    it('should fallback to href to href="javascript:void(0);" if the prop is not provided', function () {
        var component = (0, _enzyme.shallow)(_react2.default.createElement(_index2.default, { label: 'index' }));

        expect(component.find('a[href="javascript:void(0);"]').exists()).toBe(true);
    });
    it('should fallback to href to href passed', function () {
        var component = (0, _enzyme.shallow)(_react2.default.createElement(_index2.default, { label: 'index', href: 'index' }));

        expect(component.find('a[href="index"]').exists()).toBe(true);
    });
    it('should invoke onClick callback when we clicked in the breadcrumb', function () {
        var onClickMockFn = jest.fn();
        var component = (0, _enzyme.shallow)(_react2.default.createElement(_index2.default, { label: 'index', onClick: onClickMockFn }));

        component.find('a').simulate('click');
        expect(onClickMockFn.mock.calls.length).toBe(1);
    });
    it('should set the label passed as children', function () {
        var component = (0, _enzyme.shallow)(_react2.default.createElement(_index2.default, { label: 'index' }));

        expect(component.find('a').text()).toBe('index');
    });
});