'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<ButtonIcon/> in the Button component', function () {
    it('should not render the Icon when isVisible is false', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, { iconName: 'utility:user', isVisible: false }));
        expect(component.find('IconSvg').exists()).toBe(false);
    });
    it('should render the Icon when isVisible is true', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, { iconName: 'utility:user', isVisible: true }));
        expect(component.find('IconSvg').exists()).toBe(true);
    });
    it('should have the right class names when the isVisible is true and position is left', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, { isVisible: true, iconName: 'utility:world', position: 'left' }));
        expect(component.find('IconSvg').prop('className')).toBe('slds-button__icon slds-button__icon_left');
    });
    it('should have the right class names when the isVisible is true and position is right', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, { isVisible: true, iconName: 'utility:world', position: 'right' }));
        expect(component.find('IconSvg').prop('className')).toBe('slds-button__icon slds-button__icon_right');
    });
});