'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _IconSvg = require('../IconSvg');

var _IconSvg2 = _interopRequireDefault(_IconSvg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ButtonIcon(props) {
    var isVisible = props.isVisible,
        iconName = props.iconName,
        position = props.position;


    var getIconClassName = function getIconClassName() {
        return 'slds-button__icon slds-button__icon_' + position;
    };

    if (isVisible) {
        return _react2.default.createElement(_IconSvg2.default, { iconName: iconName, className: getIconClassName() });
    }
    return null;
}

ButtonIcon.propTypes = {
    isVisible: _propTypes2.default.bool.isRequired,
    iconName: _propTypes2.default.string.isRequired,
    position: _propTypes2.default.string.isRequired
};

exports.default = ButtonIcon;