'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _iconNamePropType = require('./../../propTypes/iconNamePropType');

var _iconNamePropType2 = _interopRequireDefault(_iconNamePropType);

var _IconSvg = require('../IconSvg');

var _IconSvg2 = _interopRequireDefault(_IconSvg);

var _AssistiveText = require('./../AssistiveText');

var _AssistiveText2 = _interopRequireDefault(_AssistiveText);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Buttons Icons provide the user with visual iconography that
 * is typically used to invoke an event or action.
 */
var ButtonIcon = function (_Component) {
    _inherits(ButtonIcon, _Component);

    function ButtonIcon(props) {
        _classCallCheck(this, ButtonIcon);

        var _this = _possibleConstructorReturn(this, (ButtonIcon.__proto__ || Object.getPrototypeOf(ButtonIcon)).call(this, props));

        _this.buttonRef = _react2.default.createRef();
        _this.click = _this.click.bind(_this);
        _this.focus = _this.focus.bind(_this);
        _this.blur = _this.blur.bind(_this);
        return _this;
    }

    _createClass(ButtonIcon, [{
        key: 'getIconSizeClassName',
        value: function getIconSizeClassName() {
            var _props = this.props,
                size = _props.size,
                variant = _props.variant;

            if (variant === 'base') {
                return {
                    'slds-button__icon_large': size === 'large',
                    'slds-button__icon_small': size === 'small',
                    'slds-button__icon_x-small': size === 'x-small' || size === 'xx-small'
                };
            }
            return null;
        }
    }, {
        key: 'getIconClassNames',
        value: function getIconClassNames() {
            return (0, _classnames2.default)('slds-button__icon', this.getIconSizeClassName());
        }
    }, {
        key: 'getButtonSizeClassName',
        value: function getButtonSizeClassName() {
            var _props2 = this.props,
                size = _props2.size,
                variant = _props2.variant;

            if (variant === 'base') {
                return null;
            }
            return {
                'slds-button_icon-small': size === 'small',
                'slds-button_icon-x-small': size === 'x-small',
                'slds-button_icon-xx-small': size === 'xx-small'
            };
        }
    }, {
        key: 'getVariantClassName',
        value: function getVariantClassName() {
            var variant = this.props.variant;

            if (variant === 'base') {
                return null;
            }
            return 'slds-button_icon-' + variant;
        }
    }, {
        key: 'getButtonClassNames',
        value: function getButtonClassNames() {
            var className = this.props.className;

            return (0, _classnames2.default)('slds-grid', 'slds-grid_align-center', 'slds-media_center', 'slds-button', 'slds-button_icon', this.getVariantClassName(), this.getButtonSizeClassName(), className);
        }

        /**
        * Sets focus on the element.
        * @public
        */

    }, {
        key: 'focus',
        value: function focus() {
            this.buttonRef.current.focus();
        }

        /**
        * Sets click on the element.
        * @public
        */

    }, {
        key: 'click',
        value: function click() {
            this.buttonRef.current.click();
        }

        /**
        * Sets blur on the element.
        * @public
        */

    }, {
        key: 'blur',
        value: function blur() {
            this.buttonRef.current.blur();
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                style = _props3.style,
                disabled = _props3.disabled,
                tabIndex = _props3.tabIndex,
                onFocus = _props3.onFocus,
                onBlur = _props3.onBlur,
                onClick = _props3.onClick,
                title = _props3.title,
                type = _props3.type,
                ariaHaspopup = _props3.ariaHaspopup,
                iconName = _props3.iconName,
                assistiveText = _props3.assistiveText;


            return _react2.default.createElement(
                'button',
                {
                    'data-id': 'button-icon-element',
                    className: this.getButtonClassNames(),
                    style: style,
                    disabled: disabled,
                    tabIndex: tabIndex,
                    onFocus: onFocus,
                    onBlur: onBlur,
                    onClick: onClick,
                    title: title,
                    type: type,
                    'aria-haspopup': ariaHaspopup,
                    ref: this.buttonRef },
                _react2.default.createElement(_IconSvg2.default, { iconName: iconName, className: this.getIconClassNames() }),
                _react2.default.createElement(_AssistiveText2.default, { text: assistiveText })
            );
        }
    }]);

    return ButtonIcon;
}(_react.Component);

exports.default = ButtonIcon;


ButtonIcon.propTypes = {
    /** The variant changes the appearance of buttonIcon. Accepted variants include base,
    *  brand, border, border-filled, border-inverse, inverse and container.
    * This value defaults to base. */
    variant: _propTypes2.default.oneOf(['base', 'brand', 'border', 'border-filled', 'border-inverse', 'inverse', 'container']),
    /** The Lightning Design System name of the icon used as a fallback when
    * the image fails to load. Names are written in the format {sprite_name}:{icon_name}
    * where {sprite_name} is the category, and {icon_name} is the specific icon to be displayed.
    * Only utility icons can be used in this component. */
    iconName: _iconNamePropType2.default.oneOf(['utility']).isRequired,
    /** The size of the buttonIcon. For the base variant, options include x-small, small, medium,
    * and large. For non-base variants, options include xx-small, x-small, small, and medium.
    * This value defaults to medium. */
    size: _propTypes2.default.oneOf(['xx-small', 'x-small', 'small', 'medium', 'large']),
    /** Displays tooltip text when the mouse moves over the element. */
    title: _propTypes2.default.string,
    /** Specifies the type of button. Valid values are button, reset, and submit.
    * This value defaults to button. */
    type: _propTypes2.default.oneOf(['button', 'submit', 'reset']),
    /** Specifies whether this button should be displayed in a disabled state.
    * Disabled buttons can't be clicked. This value defaults to false. */
    disabled: _propTypes2.default.bool,
    /** Specifies the tab order of an element (when the tab button is used for navigating). */
    tabIndex: _propTypes2.default.number,
    /** The action that will be run when the button is clicked. */
    onClick: _propTypes2.default.func,
    /** The action triggered when the element receives focus. */
    onFocus: _propTypes2.default.func,
    /** The action triggered when the element releases focus. */
    onBlur: _propTypes2.default.func,
    /** A description for assistive sreen readers. */
    assistiveText: _propTypes2.default.string,
    /** Indicates that the element has a popup context menu or sub-level menu. */
    ariaHaspopup: _propTypes2.default.bool,
    /** A CSS class for the outer element, in addition to the component's base classes. */
    className: _propTypes2.default.string,
    /** An object with custom style applied to the outer element. */
    style: _propTypes2.default.object
};

ButtonIcon.defaultProps = {
    variant: 'base',
    size: 'medium',
    title: undefined,
    type: 'button',
    disabled: false,
    tabIndex: undefined,
    onClick: function onClick() {},
    onFocus: function onFocus() {},
    onBlur: function onBlur() {},
    assistiveText: undefined,
    ariaHaspopup: false,
    className: undefined,
    style: undefined
};