'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _menuContent = require('./../menuContent');

var _menuContent2 = _interopRequireDefault(_menuContent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<MenuContent/>', function () {
    it('should render the Spinner when isLoading is true', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(
            _menuContent2.default,
            { isLoading: true },
            _react2.default.createElement('span', null)
        ));
        expect(component.find('Spinner').exists()).toBe(true);
    });
    it('should pass the right props to Spinner when isLoading is true', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(
            _menuContent2.default,
            { isLoading: true },
            _react2.default.createElement('span', null)
        ));
        expect(component.find('Spinner').props()).toEqual(expect.objectContaining({
            assistiveText: 'loading menu',
            isVisible: true,
            size: 'small'
        }));
    });
    it('should render the children passed when isLoading is false', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(
            _menuContent2.default,
            { isLoading: false },
            _react2.default.createElement(
                'span',
                null,
                'content'
            )
        ));
        expect(component.find('Spinner').exists()).toBe(false);
        expect(component.find('span').text()).toBe('content');
    });
});