'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _cardBody = require('./../cardBody');

var _cardBody2 = _interopRequireDefault(_cardBody);

var _Spinner = require('../../Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<CardBody/>', function () {
    it('should render the Spinner when isLoading is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(
            _cardBody2.default,
            { isLoading: true },
            'Test'
        ));
        expect(component.find(_Spinner2.default).exists()).toBe(true);
    });
    it('should not render the Spinner when isLoading is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(
            _cardBody2.default,
            null,
            'Test'
        ));
        expect(component.find(_Spinner2.default).exists()).toBe(false);
    });
    it('should render the children when isLoading is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(
            _cardBody2.default,
            null,
            _react2.default.createElement(
                'div',
                null,
                'Test'
            )
        ));
        expect(component.text()).toBe('Test');
    });
    it('should not render the children when isLoading is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(
            _cardBody2.default,
            { isLoading: true },
            'Test'
        ));
        expect(component.text()).toBeFalsy();
    });
});