'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _enzyme = require('enzyme');

var _index = require('./../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<Icon/>', function () {
    it('should set the title passed to the container element', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { iconName: 'custom:custom5', title: 'icon title' }));
        expect(component.find('.slds-icon_container').prop('title')).toBe('icon title');
    });
    it('should set the assistiveText passed as the text prop in AssistiveText component', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { iconName: 'custom:custom5', assistiveText: 'assitive description' }));
        expect(component.find('AssistiveText').prop('text')).toBe('assitive description');
    });
    it('should have the right class names when size and variant are not passed', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'custom:custom5' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when custom className and svgClassName are passed', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'utility:adduser', className: 'my-custom-class-name', svgClassName: 'my-custom-svg-class-name' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is xx-small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'utility:ad_set', size: 'xx-small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is x-small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'doctype:box_notes', size: 'x-small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'custom:custom6', size: 'small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is medium', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'standard:action_list_component', size: 'medium' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is large', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'action:add_photo_video', size: 'large' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant is default', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'utility:animal_and_nature', variant: 'default' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant is light', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'utility:answer', variant: 'light' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant is error', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'utility:approval', variant: 'error' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant is warning', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'utility:approval', variant: 'warning' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant is passed and the sprite is other than utility', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'action:add_contact', variant: 'warning' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is xx-small and the sprite is action', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'action:add_contact', size: 'xx-small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is x-small and the sprite is custom', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { iconName: 'custom:custom5', size: 'x-small' }));
        expect(component).toMatchSnapshot();
    });
});