'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.isUtilitySprite = isUtilitySprite;
exports.isActionSprite = isActionSprite;
exports.isCustomSprite = isCustomSprite;
exports.isStandardSprite = isStandardSprite;
exports.normalizeIconName = normalizeIconName;
exports.hasBackgroundColor = hasBackgroundColor;
var UTILITY_REGEX = /^utility:.+/;
var ACTION_REGEX = /^action:.+/;
var CUSTOM_REGEX = /^custom:.+/;
var STANDARD_REGEX = /^standard:.+/;

function isUtilitySprite(iconName) {
    return UTILITY_REGEX.test(iconName);
}

function isActionSprite(iconName) {
    return ACTION_REGEX.test(iconName);
}

function isCustomSprite(iconName) {
    return CUSTOM_REGEX.test(iconName);
}

function isStandardSprite(iconName) {
    return STANDARD_REGEX.test(iconName);
}

function normalizeIconName(iconName) {
    return iconName.replace(/_/g, '-').replace(':', '-');
}

function hasBackgroundColor(iconName) {
    return isActionSprite(iconName) || isCustomSprite(iconName) || isStandardSprite(iconName);
}