'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _index = require('./../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<IconSvg/>', function () {
    it('should not render the svg when the iconName format is wrong', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { iconName: 'wrong-name' }));
        expect(component.find('svg').exists()).toBe(false);
    });
    it('should render the svg element when the iconName format is valid', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { iconName: 'utility:like' }));
        expect(component.find('svg').exists()).toBe(true);
    });
    it('should set the aria-hidden to true in svg element', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { iconName: 'utility:like' }));
        expect(component.find('svg').prop('aria-hidden')).toBe(true);
    });
    it('should set the right href value in use element', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { iconName: 'action:add_contact' }));
        expect(component.find('use').prop('href')).toBe('/icons/action-sprite/svg/symbols.svg#add_contact');
    });
});