'use strict';

var _utils = require('./../utils');

describe('IconSvg utils', function () {
    describe('isIconNameValid', function () {
        it('should return true if the icon name has a valid format', function () {
            expect((0, _utils.isIconNameValid)('utility:add_contact')).toBe(true);
        });
        it('should return false if the icon name has an invalid format', function () {
            expect((0, _utils.isIconNameValid)('wrong-name')).toBe(false);
        });
    });
    describe('getSpriteName', function () {
        it('should return the sprite part of the icon name', function () {
            expect((0, _utils.getSpriteName)('action:add_contact')).toBe('action');
        });
        it('should return the same string passed when there is not a : character', function () {
            expect((0, _utils.getSpriteName)('action-add_contact')).toBe('action-add_contact');
        });
    });
    describe('getIconName', function () {
        it('should return the icon name part of the icon name', function () {
            expect((0, _utils.getIconName)('action:add_contact')).toBe('add_contact');
        });
        it('should return the same string passed when there is not a : character', function () {
            expect((0, _utils.getSpriteName)('add_contact')).toBe('add_contact');
        });
    });
});