'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /* eslint-disable react/prop-types */


exports.default = IconSvg;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _iconNamePropType = require('./../../propTypes/iconNamePropType');

var _iconNamePropType2 = _interopRequireDefault(_iconNamePropType);

var _Application = require('./../Application');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Svg(props) {
    var className = props.className,
        style = props.style,
        iconName = props.iconName,
        assetsSrc = props.assetsSrc;


    var resolveSrc = function resolveSrc() {
        return assetsSrc || '';
    };

    if ((0, _utils.isIconNameValid)(iconName)) {
        var sprite = (0, _utils.getSpriteName)(iconName);
        var icon = (0, _utils.getIconName)(iconName);

        return _react2.default.createElement(
            'svg',
            { className: className, style: style, 'aria-hidden': true },
            _react2.default.createElement('use', { xmlnsXlink: 'http://www.w3.org/1999/xlink', href: resolveSrc() + '/icons/' + sprite + '-sprite/svg/symbols.svg#' + icon })
        );
    }
    return null;
}

function IconSvg(props) {
    return _react2.default.createElement(
        _Application.Consumer,
        null,
        function (values) {
            return _react2.default.createElement(Svg, _extends({}, props, values));
        }
    );
}

IconSvg.propTypes = {
    /** The Lightning Design System name of the icon used as a fallback when
    * the image fails to load. Names are written in the format {sprite_name}:{icon_name}
    * where {sprite_name} is the category, and {icon_name} is the specific icon to be displayed. */
    iconName: _iconNamePropType2.default.simple.isRequired,
    /** A CSS class for the outer element, in addition to the component's base classes. */
    className: _propTypes2.default.string,
    /** An object with custom style applied to the outer element. */
    style: _propTypes2.default.object
};

IconSvg.defaultProps = {
    className: undefined,
    style: undefined
};