'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _error = require('./../error');

var _error2 = _interopRequireDefault(_error);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<InputError/>', function () {
    it('should not render the error when it is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_error2.default, null));
        expect(component.find('div[className="slds-form-element__help"]').exists()).toBe(false);
    });
    it('should render the error passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_error2.default, { error: 'Error text' }));
        var error = component.find('div[className="slds-form-element__help"]');
        expect(error.exists()).toBe(true);
        expect(error.text()).toBe('Error text');
    });
    it('should set the id passed as the id prop in the error container element', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_error2.default, { error: 'Error text', id: 'error-message-125' }));
        var error = component.find('div[className="slds-form-element__help"]');
        expect(error.prop('id')).toBe('error-message-125');
    });
});