'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _icon = require('./../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<InputIcon/>', function () {
    it('should not render the IconSvg when iconName is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, null));
        expect(component.find('IconSvg').exists()).toBe(false);
    });
    it('should render the IconSvg when iconName is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, { iconName: 'utility:user' }));
        expect(component.find('IconSvg').exists()).toBe(true);
    });
    it('should have the right class names when iconName is passed and the position is left', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_icon2.default, { iconName: 'utility:activity', position: 'left' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when iconName is passed and the position is right', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_icon2.default, { iconName: 'utility:activity', position: 'right' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when there is an error and the position is left', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_icon2.default, { iconName: 'utility:activity', error: 'input error', position: 'left' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when there is an error and the position is right', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_icon2.default, { iconName: 'utility:activity', error: 'input error', position: 'right' }));
        expect(component).toMatchSnapshot();
    });
});