'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _label = require('./../label');

var _label2 = _interopRequireDefault(_label);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<InputLabel/>', function () {
    it('should not render the label when is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_label2.default, null));
        expect(component.find('label').exists()).toBe(false);
    });
    it('should render the label when it is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_label2.default, { label: 'Label text' }));
        var label = component.find('label');
        expect(label.exists()).toBe(true);
        expect(label.text()).toBe('Label text');
    });
    it('should set the inputId passed as the htmlFor prop in the label element', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_label2.default, { label: 'Input Label', inputId: 'input-213' }));
        expect(component.find('label').prop('htmlFor')).toBe('input-213');
    });
    it('should set the id passed as the id prop in the label element', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_label2.default, { label: 'Input Label', id: 'label-123' }));
        expect(component.find('label').prop('id')).toBe('label-123');
    });
    it('should set the required prop passed in the RequiredAsterisk component', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_label2.default, { label: 'Input Label', required: true }));
        expect(component.find('RequiredAsterisk').prop('required')).toBe(true);
    });
    it('should have the right class names when a custom class name is passed', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_label2.default, { label: 'Input Label', className: 'my-custom-class-name' }));
        expect(component).toMatchSnapshot();
    });
});