'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _requiredAsterisk = require('./../requiredAsterisk');

var _requiredAsterisk2 = _interopRequireDefault(_requiredAsterisk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<InputRequiredAsterisk/>', function () {
    it('should not render the abbr element when is not required', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_requiredAsterisk2.default, { required: false }));
        expect(component.find('abbr[className="slds-required"]').exists()).toBe(false);
    });
    it('should render the abbr element when is required', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_requiredAsterisk2.default, { required: true }));
        var asterisk = component.find('abbr[className="slds-required"]');
        expect(asterisk.exists()).toBe(true);
        expect(asterisk.text()).toBe('* ');
    });
    it('should set the title prop as required in the abbr element when is required', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_requiredAsterisk2.default, { required: true }));
        var asterisk = component.find('abbr[className="slds-required"]');
        expect(asterisk.prop('title')).toBe('required');
    });
});