'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Icon;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _IconSvg = require('../IconSvg');

var _IconSvg2 = _interopRequireDefault(_IconSvg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Icon(props) {
    var iconName = props.iconName,
        position = props.position,
        error = props.error;


    var getIconClassNames = function getIconClassNames() {
        if (error) {
            return 'slds-input__icon slds-input__icon_' + position;
        }
        return (0, _classnames2.default)('slds-icon slds-input__icon slds-icon-text-default', 'slds-input__icon_' + position);
    };

    if (iconName) {
        return _react2.default.createElement(_IconSvg2.default, { iconName: iconName, className: getIconClassNames() });
    }
    return null;
}

Icon.propTypes = {
    iconName: _propTypes2.default.string,
    error: _propTypes2.default.node,
    position: _propTypes2.default.string.isRequired
};

Icon.defaultProps = {
    iconName: undefined,
    error: null
};