'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _utils = require('./../../libs/utils');

var _iconNamePropType = require('./../../propTypes/iconNamePropType');

var _iconNamePropType2 = _interopRequireDefault(_iconNamePropType);

var _icon = require('./icon');

var _icon2 = _interopRequireDefault(_icon);

var _help = require('./help');

var _help2 = _interopRequireDefault(_help);

var _error = require('./error');

var _error2 = _interopRequireDefault(_error);

var _label = require('./label');

var _label2 = _interopRequireDefault(_label);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Text inputs are used for freeform data entry.
 */
var Input = function (_Component) {
    _inherits(Input, _Component);

    function Input(props) {
        _classCallCheck(this, Input);

        var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

        _this.inputId = (0, _utils.uniqueId)('input');
        _this.inlineTextLabelId = (0, _utils.uniqueId)('inline-text-label');
        _this.errorMessageId = (0, _utils.uniqueId)('error-message');
        return _this;
    }

    _createClass(Input, [{
        key: 'getContainerClassNames',
        value: function getContainerClassNames() {
            var _props = this.props,
                className = _props.className,
                error = _props.error;

            return (0, _classnames3.default)('slds-form-element', { 'slds-has-error': error }, className);
        }
    }, {
        key: 'getFormControlClassNames',
        value: function getFormControlClassNames() {
            var _props2 = this.props,
                iconName = _props2.iconName,
                iconPosition = _props2.iconPosition;

            return (0, _classnames3.default)('slds-form-element__control', _defineProperty({
                'slds-input-has-icon': iconName
            }, 'slds-input-has-icon_' + iconPosition, iconName));
        }
    }, {
        key: 'getInputClassNames',
        value: function getInputClassNames() {
            var _props3 = this.props,
                isBare = _props3.isBare,
                isCentered = _props3.isCentered;

            return (0, _classnames3.default)('slds-input', {
                'slds-input_bare': isBare,
                'slds-input_counter': isCentered
            });
        }
    }, {
        key: 'getInlineTextLabelId',
        value: function getInlineTextLabelId() {
            var bottomHelpText = this.props.bottomHelpText;

            if (bottomHelpText) {
                return this.inlineTextLabelId;
            }
            return undefined;
        }
    }, {
        key: 'getErrorMessageId',
        value: function getErrorMessageId() {
            var error = this.props.error;

            if (error) {
                return this.errorMessageId;
            }
            return undefined;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props4 = this.props,
                style = _props4.style,
                value = _props4.value,
                onChange = _props4.onChange,
                label = _props4.label,
                error = _props4.error,
                placeholder = _props4.placeholder,
                disabled = _props4.disabled,
                readOnly = _props4.readOnly,
                tabIndex = _props4.tabIndex,
                type = _props4.type,
                maxLength = _props4.maxLength,
                minLength = _props4.minLength,
                pattern = _props4.pattern,
                labelClassName = _props4.labelClassName,
                iconName = _props4.iconName,
                iconPosition = _props4.iconPosition,
                bottomHelpText = _props4.bottomHelpText,
                required = _props4.required;

            var isRequiredOrHasError = !!(required || error);

            return _react2.default.createElement(
                'div',
                { className: this.getContainerClassNames(), style: style },
                _react2.default.createElement(_label2.default, {
                    className: labelClassName,
                    label: label,
                    required: isRequiredOrHasError,
                    inputId: this.inputId,
                    id: this.getInlineTextLabelId() }),
                _react2.default.createElement(
                    'div',
                    { className: this.getFormControlClassNames() },
                    _react2.default.createElement(_icon2.default, {
                        iconName: iconName,
                        position: iconPosition,
                        error: error }),
                    _react2.default.createElement('input', {
                        id: this.inputId,
                        type: type,
                        className: this.getInputClassNames(),
                        value: value,
                        placeholder: placeholder,
                        onChange: onChange,
                        tabIndex: tabIndex,
                        disabled: disabled,
                        readOnly: readOnly,
                        required: isRequiredOrHasError,
                        maxLength: maxLength,
                        minLength: minLength,
                        pattern: pattern,
                        'aria-labelledby': this.getInlineTextLabelId(),
                        'aria-describedby': this.getErrorMessageId() })
                ),
                _react2.default.createElement(_help2.default, { text: bottomHelpText }),
                _react2.default.createElement(_error2.default, { id: this.getErrorMessageId(), error: error })
            );
        }
    }]);

    return Input;
}(_react.Component);

exports.default = Input;


Input.propTypes = {
    /** Specifies the value of an input element. */
    value: _propTypes2.default.string,
    /** The type of the input. This value defaults to text. */
    type: _propTypes2.default.oneOf(['text', 'password', 'datetime', 'datetime-local', 'date', 'month', 'time', 'week', 'number', 'email', 'url', 'search', 'tel', 'color']),
    /** The input label */
    label: _propTypes2.default.node,
    /** Text that is displayed when the field is empty, to prompt the user for a valid entry. */
    placeholder: _propTypes2.default.string,
    /** The Lightning Design System name of the icon used as a fallback when
     * the image fails to load. Names are written in the format {sprite_name}:{icon_name}
     * where {sprite_name} is the category, and {icon_name} is the specific icon to be displayed.
     * Only utility icons can be used in this component. */
    iconName: _iconNamePropType2.default.oneOf(['utility']),
    /** Describes the position of the icon with respect to body. Options include left and right.
     * This value defaults to left. */
    iconPosition: _propTypes2.default.oneOf(['left', 'right']),
    /** The maximum number of characters allowed in the field. */
    maxLength: _propTypes2.default.number,
    /** The minimum number of characters allowed in the field. */
    minLength: _propTypes2.default.number,
    /** Shows the help message below the input. */
    bottomHelpText: _propTypes2.default.node,
    /** Specifies that an input field must be filled out before submitting the form.
     * This value defaults to false. */
    required: _propTypes2.default.bool,
    /** Specifies the regular expression that the input's value is checked against.
     * This attribute is supported for text, search, url, tel, email, and password types. */
    pattern: _propTypes2.default.string,
    /** Specifies that an input text will be centered. This value defaults to false. */
    isCentered: _propTypes2.default.bool,
    /** Specifies that an input will not have border. This value defaults to false. */
    isBare: _propTypes2.default.bool,
    /** Specifies that an input field must be filled out before submitting the form.
     * This value defaults to false. */
    error: _propTypes2.default.node,
    /** Specifies that an input element should be disabled. This value defaults to false. */
    disabled: _propTypes2.default.bool,
    /** Specifies that an input field is read-only. This value defaults to false. */
    readOnly: _propTypes2.default.bool,
    /** The action triggered when a value attribute changes. */
    onChange: _propTypes2.default.func,
    /** Specifies the tab order of an element (when the tab button is used for navigating). */
    tabIndex: _propTypes2.default.number,
    /** A CSS class for the outer element, in addition to the component's base classes. */
    className: _propTypes2.default.string,
    /** A CSS class for the label element, in addition to the label's base classes. */
    labelClassName: _propTypes2.default.string,
    /** An object with custom style applied to the outer element. */
    style: _propTypes2.default.object
};

Input.defaultProps = {
    value: undefined,
    type: 'text',
    label: null,
    placeholder: null,
    iconName: undefined,
    iconPosition: 'left',
    maxLength: undefined,
    minLength: undefined,
    bottomHelpText: null,
    required: false,
    pattern: undefined,
    isCentered: false,
    isBare: false,
    error: null,
    disabled: false,
    readOnly: false,
    onChange: function onChange() {},
    tabIndex: undefined,
    className: undefined,
    labelClassName: undefined,
    style: undefined
};