'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Label;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _requiredAsterisk = require('./requiredAsterisk');

var _requiredAsterisk2 = _interopRequireDefault(_requiredAsterisk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Label(props) {
    var className = props.className,
        label = props.label,
        required = props.required,
        inputId = props.inputId,
        id = props.id;


    var getLabelClassNames = function getLabelClassNames() {
        return (0, _classnames2.default)('slds-form-element__label', className);
    };

    if (label) {
        return _react2.default.createElement(
            'label',
            { className: getLabelClassNames(), htmlFor: inputId, id: id },
            _react2.default.createElement(_requiredAsterisk2.default, { required: required }),
            label
        );
    }
    return null;
}

Label.propTypes = {
    className: _propTypes2.default.string,
    label: _propTypes2.default.node,
    required: _propTypes2.default.bool.isRequired,
    inputId: _propTypes2.default.string.isRequired,
    id: _propTypes2.default.string
};

Label.defaultProps = {
    className: undefined,
    label: null,
    id: undefined
};