'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Icon;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _iconNamePropType = require('./../../propTypes/iconNamePropType');

var _iconNamePropType2 = _interopRequireDefault(_iconNamePropType);

var _IconSvg = require('./../IconSvg');

var _IconSvg2 = _interopRequireDefault(_IconSvg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Icon(_ref) {
    var iconName = _ref.iconName,
        isVisible = _ref.isVisible,
        position = _ref.position;

    var getIconClassNames = function getIconClassNames() {
        return (0, _classnames2.default)('slds-icon slds-icon_x-small slds-icon-text-default', {
            'slds-m-right_small': position === 'left',
            'slds-m-left_small slds-shrink-none': position === 'right'
        });
    };

    if (isVisible) {
        return _react2.default.createElement(_IconSvg2.default, {
            iconName: iconName,
            className: getIconClassNames() });
    }
    return null;
}

Icon.propTypes = {
    iconName: _iconNamePropType2.default.simple,
    isVisible: _propTypes2.default.bool.isRequired,
    position: _propTypes2.default.string.isRequired
};

Icon.defaultProps = {
    iconName: undefined
};