'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = MenuItem;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _iconNamePropType = require('./../../propTypes/iconNamePropType');

var _iconNamePropType2 = _interopRequireDefault(_iconNamePropType);

var _context = require('./../ButtonMenu/context');

var _icon = require('./icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable no-script-url, react/prop-types */


var Item = function (_Component) {
    _inherits(Item, _Component);

    function Item(props) {
        _classCallCheck(this, Item);

        var _this = _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).call(this, props));

        _this.itemRef = _react2.default.createRef();
        _this.handleClick = _this.handleClick.bind(_this);
        return _this;
    }

    _createClass(Item, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            var _props = this.props,
                privateRegisterChild = _props.privateRegisterChild,
                disabled = _props.disabled,
                variant = _props.variant;

            var isHeader = variant === 'header';
            if (disabled || isHeader) {
                return null;
            }
            return setTimeout(function () {
                return privateRegisterChild(_this2.itemRef.current);
            }, 0);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var privateUnregisterChild = this.props.privateUnregisterChild;

            return privateUnregisterChild(this.itemRef.current);
        }
    }, {
        key: 'getHeaderClassNames',
        value: function getHeaderClassNames() {
            var className = this.props.className;

            return (0, _classnames2.default)('slds-dropdown__header slds-truncate', className);
        }
    }, {
        key: 'getItemClassNames',
        value: function getItemClassNames() {
            var className = this.props.className;

            return (0, _classnames2.default)('slds-dropdown__item', className);
        }
    }, {
        key: 'handleClick',
        value: function handleClick(event) {
            var _props2 = this.props,
                disabled = _props2.disabled,
                onClick = _props2.onClick,
                privateOnClose = _props2.privateOnClose;

            if (disabled) {
                return null;
            }
            onClick(event);
            return privateOnClose();
        }
    }, {
        key: 'click',
        value: function click() {
            this.itemRef.current.click();
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                style = _props3.style,
                label = _props3.label,
                title = _props3.title,
                variant = _props3.variant,
                iconName = _props3.iconName,
                iconPosition = _props3.iconPosition,
                disabled = _props3.disabled;


            if (variant === 'header') {
                return _react2.default.createElement(
                    'li',
                    { className: this.getHeaderClassNames(), style: style, title: title, role: 'separator' },
                    _react2.default.createElement(
                        'span',
                        { className: 'slds-text-title_caps' },
                        label
                    )
                );
            }

            var hasLeftIcon = !!(iconName && iconPosition === 'left');
            var hasRightIcon = !!(iconName && iconPosition === 'right');

            return _react2.default.createElement(
                'li',
                { className: this.getItemClassNames(), style: style, role: 'presentation', onClick: this.handleClick },
                _react2.default.createElement(
                    'a',
                    {
                        href: 'javascript:void(0);',
                        role: 'menuitem',
                        'aria-disabled': disabled,
                        ref: this.itemRef },
                    _react2.default.createElement(
                        'span',
                        { className: 'slds-truncate', title: title },
                        _react2.default.createElement(_icon2.default, {
                            'data-id': 'menu-item-left-icon',
                            iconName: iconName,
                            isVisible: hasLeftIcon,
                            position: iconPosition }),
                        label
                    ),
                    _react2.default.createElement(_icon2.default, {
                        'data-id': 'menu-item-right-icon',
                        iconName: iconName,
                        isVisible: hasRightIcon,
                        position: iconPosition })
                )
            );
        }
    }]);

    return Item;
}(_react.Component);

/**
* Represents a list item in a menu.
*/


function MenuItem(props) {
    return _react2.default.createElement(
        _context.Consumer,
        null,
        function (values) {
            return _react2.default.createElement(Item, _extends({}, props, values));
        }
    );
}

MenuItem.propTypes = {
    /** Text of the menu item. */
    label: _propTypes2.default.node.isRequired,
    /** The variant changes the type of menu item. Accepted variants include default and header.
    * This value defaults to default. */
    variant: _propTypes2.default.oneOf(['default', 'header']),
    /** The Lightning Design System name of the icon used as a fallback when
    * the image fails to load. Names are written in the format {sprite_name}:{icon_name}
    * where {sprite_name} is the category, and {icon_name} is the specific icon to be displayed.
    * Only utility icons can be used in this component. */
    iconName: _iconNamePropType2.default.oneOf(['utility']),
    /** Describes the position of the icon with respect to body. Options include left and right.
    * This value defaults to left. */
    iconPosition: _propTypes2.default.oneOf(['left', 'right']),
    /** If true the menu item is not actionable and is shown as disabled. */
    disabled: _propTypes2.default.bool,
    /** The action triggered when the breadcrumb is clicked. */
    onClick: _propTypes2.default.func,
    /** Displays tooltip text when the mouse moves over the element. */
    title: _propTypes2.default.string,
    /** A CSS class for the outer element, in addition to the component's base classes. */
    className: _propTypes2.default.string,
    /** An object with custom style applied to the outer element. */
    style: _propTypes2.default.object
};

MenuItem.defaultProps = {
    variant: 'default',
    iconName: undefined,
    iconPosition: 'left',
    disabled: false,
    onClick: function onClick() {},
    title: undefined,
    className: undefined,
    style: undefined
};