'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _index = require('./../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<ProgressBar/>', function () {
    it('should has set the value passed', function () {
        var component = (0, _enzyme.shallow)(_react2.default.createElement(_index2.default, { value: 25 }));

        expect(component.find('span.slds-progress-bar__value').prop('style').width).toBe('25%');
    });
    it('should be accesible', function () {
        var component = (0, _enzyme.shallow)(_react2.default.createElement(_index2.default, { value: 25 }));

        expect(component.find('div[role="progressbar"]').exists()).toBe(true);
        expect(component.find('div[aria-valuemax="100"]').exists()).toBe(true);
        expect(component.find('div[aria-valuemin="0"]').exists()).toBe(true);
        expect(component.find('div[aria-valuenow=25]').exists()).toBe(true);
    });
    it('should have the right class names when variant, color and size default and have a custom class', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { className: 'custom-class' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant circular', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { variant: 'circular' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size large', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'large' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size medium', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'medium' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size x-small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'x-small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when color success', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { color: 'success' }));
        expect(component).toMatchSnapshot();
    });
});