'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _index = require('./../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<Spinner/>', function () {
    it('should not render the spinner when isVisible is false', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { isVisible: false }));
        expect(component.children().length).toBe(0);
    });
    it('should not render the spinner when isVisible is true', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { isVisible: true }));
        expect(component.children().length).toBe(1);
    });
    it('should have the right class names when ehiter the variant and size are not passed', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, null));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when a custom container class name is passed, variant is brand and size is large', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { variant: 'brand', size: 'large', containerClassName: 'custom-container-classname' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when variant is inverse and size is medium', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { variant: 'inverse', size: 'medium' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is x-small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'x-small' }));
        expect(component).toMatchSnapshot();
    });
    it('should have the right class names when size is xx-small', function () {
        var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { size: 'xx-small' }));
        expect(component).toMatchSnapshot();
    });
    it('should pass assistiveText to the prop text of AssistiveText component', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, { assistiveText: 'for screen readers' }));
        expect(component.find('AssistiveText').prop('text')).toBe('for screen readers');
    });
});