'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _icon = require('./../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<VerticalItemIcon/>', function () {
    it('should not render the Icon when the iconName is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, null));
        expect(component.find('Icon').exists()).toBe(false);
    });
    it('should render the Icon when the iconName is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, { iconName: 'utility:user' }));
        expect(component.find('Icon').exists()).toBe(true);
    });
    it('should pass the right props to Icon component when the iconName is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_icon2.default, { iconName: 'utility:user' }));
        expect(component.find('Icon').props()).toEqual(expect.objectContaining({
            iconName: 'utility:user',
            className: 'slds-line-height_reset',
            svgClassName: 'slds-m-right_x-small',
            size: 'x-small'
        }));
    });
});