'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _notification = require('./../notification');

var _notification2 = _interopRequireDefault(_notification);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<VerticalItemIcon/>', function () {
    it('should not render the notification when it is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_notification2.default, null));
        expect(component.find('span').exists()).toBe(false);
    });
    it('should render the Notification when it is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_notification2.default, { notification: '2' }));
        expect(component.find('span').exists()).toBe(true);
        expect(component.text()).toBe('2');
    });
    it('should pass the right className to the span element when the notification is passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_notification2.default, { notification: '3' }));
        expect(component.find('span').prop('className')).toBe('slds-col_bump-left');
    });
});