'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _header = require('./../header');

var _header2 = _interopRequireDefault(_header);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<VerticalSectionHeader/>', function () {
    it('should not render the label passed when is not passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_header2.default, null));
        expect(component.find('h2').exists()).toBe(false);
    });
    it('should render the label passed', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_header2.default, { label: 'header section label' }));
        expect(component.find('h2').exists()).toBe(true);
        expect(component.find('h2').text()).toBe('header section label');
    });
    it('should set the id passed in the h2 element', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_header2.default, { label: 'header section label', id: 'header-12' }));
        expect(component.find('h2').prop('id')).toBe('header-12');
    });
    it('should pass the right className to h2 element', function () {
        var component = (0, _enzyme.mount)(_react2.default.createElement(_header2.default, { label: 'header section label' }));
        expect(component.find('h2').prop('className')).toBe('slds-nav-vertical__title slds-text-title_caps');
    });
});