'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _IconSvg = require('./../IconSvg');

var _IconSvg2 = _interopRequireDefault(_IconSvg);

var _label = require('./label');

var _label2 = _interopRequireDefault(_label);

var _AssistiveText = require('./../AssistiveText');

var _AssistiveText2 = _interopRequireDefault(_AssistiveText);

var _utils = require('./../../libs/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var searchResultsId = (0, _utils.uniqueId)('search-results');

/**
* Represents an overflow of items from a preceding VerticalNavigationSection,
* with the ability to toggle visibility.
*/

var VerticalSectionOverflow = function (_Component) {
    _inherits(VerticalSectionOverflow, _Component);

    function VerticalSectionOverflow(props) {
        _classCallCheck(this, VerticalSectionOverflow);

        var _this = _possibleConstructorReturn(this, (VerticalSectionOverflow.__proto__ || Object.getPrototypeOf(VerticalSectionOverflow)).call(this, props));

        _this.state = {
            isExpanded: props.expanded
        };
        _this.toggleOverflow = _this.toggleOverflow.bind(_this);
        return _this;
    }

    _createClass(VerticalSectionOverflow, [{
        key: 'getContainerClassNames',
        value: function getContainerClassNames() {
            var className = this.props.className;

            return (0, _classnames2.default)('slds-nav-vertical__overflow', className);
        }
    }, {
        key: 'getOverflowClassName',
        value: function getOverflowClassName() {
            var isExpanded = this.state.isExpanded;

            if (isExpanded) {
                return 'slds-show';
            }
            return 'slds-hide';
        }
    }, {
        key: 'toggleOverflow',
        value: function toggleOverflow() {
            var isExpanded = this.state.isExpanded;

            this.setState({ isExpanded: !isExpanded });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                expandedLabel = _props.expandedLabel,
                collapsedLabel = _props.collapsedLabel,
                style = _props.style,
                assistiveText = _props.assistiveText,
                children = _props.children;
            var isExpanded = this.state.isExpanded;


            return _react2.default.createElement(
                'div',
                { className: this.getContainerClassNames(), style: style },
                _react2.default.createElement(
                    'button',
                    {
                        className: 'slds-button slds-button_reset slds-nav-vertical__action slds-nav-vertical__action_overflow',
                        'aria-controls': searchResultsId,
                        'aria-expanded': isExpanded,
                        onClick: this.toggleOverflow },
                    _react2.default.createElement(_IconSvg2.default, { iconName: 'utility:chevronright', className: 'slds-button__icon slds-button__icon_left' }),
                    _react2.default.createElement(
                        'span',
                        { className: 'slds-nav-vertical__action-text' },
                        _react2.default.createElement(_label2.default, {
                            isExpanded: isExpanded,
                            expandedLabel: expandedLabel,
                            collapsedLabel: collapsedLabel }),
                        _react2.default.createElement(_AssistiveText2.default, { text: assistiveText })
                    )
                ),
                _react2.default.createElement(
                    'div',
                    { 'data-id': 'vertical-overflow', id: searchResultsId, className: this.getOverflowClassName() },
                    _react2.default.createElement(
                        'ul',
                        null,
                        children
                    )
                )
            );
        }
    }]);

    return VerticalSectionOverflow;
}(_react.Component);

exports.default = VerticalSectionOverflow;


VerticalSectionOverflow.propTypes = {
    /** The label to show when the section is collapsed. */
    collapsedLabel: _propTypes2.default.node,
    /** The label to show when the section is expanded. */
    expandedLabel: _propTypes2.default.node,
    /** The state of the overflow. */
    expanded: _propTypes2.default.bool,
    /** A description for assistive sreen readers. */
    assistiveText: _propTypes2.default.string,
    /** A CSS class for the outer element, in addition to the component's base classes. */
    className: _propTypes2.default.string,
    /** An object with custom style applied for the outer element. */
    style: _propTypes2.default.object,
    /**
    * This prop that should not be visible in the documentation.
    * @ignore
    */
    children: _propTypes2.default.node
};

VerticalSectionOverflow.defaultProps = {
    expandedLabel: 'Show Less',
    collapsedLabel: 'Show More',
    expanded: false,
    className: undefined,
    style: undefined,
    assistiveText: undefined,
    children: null
};