"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = createChainableTypeChecker;
function createChainableTypeChecker(validate, iconPrefixes) {
    function checkType(isRequired, props, propName, componentName) {
        var iconName = props.iconName;

        if (iconName == null) {
            if (isRequired) {
                return new Error("Required `" + propName + "` was not specified in " + ("`" + componentName + "`."));
            }
            return null;
        }
        return validate(iconPrefixes, props, propName, componentName);
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
}