'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = iconNamePropTypeValidator;
var allowedPrefixes = ['action', 'custom', 'doctype', 'standard', 'utility'];

function iconNamePropTypeValidator(iconPrefixes, props, propName, componentName) {
    var iconName = props.iconName;

    var iconPrefixesToTry = iconPrefixes || allowedPrefixes;
    if (iconName !== undefined && iconName !== null && iconName !== '') {
        var _iconName$split = iconName.split(':'),
            _iconName$split2 = _slicedToArray(_iconName$split, 1),
            prefix = _iconName$split2[0];

        if (prefix === iconName || iconPrefixesToTry.find(function (p) {
            return p === prefix;
        }) === undefined) {
            return new Error('Invalid prop `' + propName + '` supplied to `' + componentName + '`, expected a string in the format of {sprite}:{icon_name}, where sprite is one of [ ' + iconPrefixesToTry.toString() + ' ].');
        }
    }
    return null;
}